/* Copyright Statement:
 *
 * This software/firmware and related documentation ("AutoChips Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to AutoChips Inc. and/or its licensors. Without
 * the prior written permission of AutoChips inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of AutoChips Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * AutoChips Inc. (C) 2024. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("AUTOCHIPS SOFTWARE")
 * RECEIVED FROM AUTOCHIPS AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. AUTOCHIPS EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES AUTOCHIPS PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE AUTOCHIPS SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN AUTOCHIPS
 * SOFTWARE. AUTOCHIPS SHALL ALSO NOT BE RESPONSIBLE FOR ANY AUTOCHIPS SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND AUTOCHIPS'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE AUTOCHIPS SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT AUTOCHIPS'S OPTION, TO REVISE OR REPLACE THE
 * AUTOCHIPS SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO AUTOCHIPS FOR SUCH AUTOCHIPS SOFTWARE AT ISSUE.
 */
/******************************************************************************
 * @version: V3.1.0  AC7840x  Demo
 ******************************************************************************/

#include "adc_sample.h"
#include "debugout_ac7840x.h"
#include "clock_config.h"
#include "osif.h"
#include "gpio.h"
#include "spm_drv.h"
#include "ckgen_hw.h"

/*!
 *例程说明：
 *1、休眠唤醒例程。使用AMO监控电位器对应通道电压，当电压变化时触发AMO中断退出休眠模式。
 */

/*!
 * @brief 时钟配置函数.
 *
 * @param[in] none
 *
 * @return none
 */
void SystemClock_Config(void)
{
    CKGEN_SYS_Init(g_clockManConfigsArr, CLOCK_MANAGER_CONFIG_CNT,
                   g_clockManCallbacksArr, CLOCK_MANAGER_CALLBACK_CNT);
    CKGEN_DRV_UpdateConfiguration(0, CLOCK_MANAGER_POLICY_AGREEMENT);
}

/*!
 * @brief main
 *
 * @param[in]  none
 *
 * @return 0: success, other: error value
 */
int main(void)
{
    SystemClock_Config(); /*! 时钟初始化*/
    InitDebug();          /*! 初始化串口打印*/
    printf("ADC VLPS Test\r\n");

    ADC_Init();           /*! ADC初始化*/
    GPIO_LedInit();       /*! LED初始化*/
    GPIO_KeyInit();       /*! 按键初始化*/
    LED3_ON;              /*! 上电后点亮LED3*/
    OSIF_TimeDelay(2000); /*! tick延时2s，防止上电就进入休眠*/

    while (1)
    {
        OSIF_TimeDelay(200); /*! tick延时200ms*/
        ADC_PrintTest();     /*! 打印ADC转换结果*/
        LED3_TOGGLE;

        if (Get_Key4Value()) /*! 判断KEY4是否按下 */
        {
            printf("\r\nsystem go to vlps \r\n");            /*! 休眠前Log打印 */
            OSIF_TimeDelay(1);                               /*! 延时1ms，确保打印完成*/
            CKGEN_SetPeripheralClock(ADC0_CLK, HSIDIV2_CLK); /*! ADC在进入低功耗模式前需要将ADC的时钟源选为HSI。*/
            LED3_OFF;                                        /*! 休眠前关掉LED3*/
            SPM_DRV_SetPowerMode(POWER_MODE_VLPS);           /*! 进入低功耗停止模式（VLPS），等待AMO中断唤醒*/

            CKGEN_SetPeripheralClock(ADC0_CLK, SPLLDIV2_CLK); /*! 退出低功耗后切换回原时钟*/
            LED3_ON;                                          /*! 唤醒后点亮LED3*/
            printf("system exit vlps \r\n");                  /*! 唤醒后打印Log */
        }
    }
}
